﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace Bug54040
{
    /// <summary>
    /// Interaction logic for Window1.xaml
    /// </summary>
    public partial class Window1 : Window
    {
        public Window1()
        {
            InitializeComponent();
        }

        private void buttonWorks_Click(object sender, RoutedEventArgs e)
        {
            runTest(32767);
        }

        private void buttonBreaks_Click(object sender, RoutedEventArgs e)
        {
            runTest(32768);
        }



        private void runTest(long value)
        {
            Console.WriteLine("Running test with {0}", value);

            StringBuilder sb = new StringBuilder();
            for (int i = 0; i < value; i++) sb.Append('X');

            // NOTE:  You will have to run   DELETE FROM t;  to clear out the table,
            //        since Entity Frameworks can't read in objects to delete them.

            using (var dc = new dEntities())
            {
                t entity = new t();
                entity.c = sb.ToString();

                dc.AddTot(entity);
                dc.SaveChanges();
            }

            using (var dc = new dEntities())
            {
                var results = from r in dc.t
                              select r;

                foreach (t entity in results) // Fails on 32768 or greater
                {
                    Console.WriteLine("{0}", entity.c.Length);
                }

            }
        }
    }
}
